<?php

namespace App\Console\Commands;

//use App\RedisModel;
use App\Log;
use App\Models\ZeanExcelRecord;
use Illuminate\Console\Command;

class ZeanExcel extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'ZeanExcel';
    protected $filename;
    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = '';

    public function handle()
    {
        \DB::connection()->disableQueryLog();

        $this->info(date('m-d H:i:s') . ' 开始整理');

  /*      $source = '品倍福-电影';
        #获取列序列
        $sourcefile1 = public_path("upload/csv/".$source).'/'.$source.'_0.Csv';

        $cn = $this->getCsvColSort($sourcefile1);

        $flitFiles = $this->readCsvFiles($source);
        foreach($flitFiles as $csvPath){
            $first = $csvPath == $sourcefile1 ? 1 : 0;
            $this->stat($csvPath, $source, 'Csv', $cn, $first); 
        }
        exit;*/

       /* $source = '品倍福-电影';
        $file = public_path("upload/csv/".$source).'/'.$source.'_0.Csv';
        $cn = $this->getCsvColSort('C:\Users\admin\Desktop\新建文件夹\博影-影城.xlsx');
        exit;*/
        //$reader = new \PhpOffice\PhpSpreadsheet\Reader\Xlsx();
        
       /* $reader = new \PhpOffice\PhpSpreadsheet\Reader\Csv();
        
        //$filePath= 'C:\Users\admin\Desktop\新建文件夹\博影-影城.xlsx';
        $filePath= 'C:\Users\admin\Desktop\工作簿2.csv';
        $filePath= 'C:\Users\admin\Desktop\品倍福-电影_0.csv';
        //$reader->setInputEncoding($strCode);
        $spreadsheet = $reader->load($filePath);
        //echo "\n yes";
        exit;*/


        $time = time();
        //$rkey = 'zean.sourceExcelExportdo';
        while(true){
            if(time()-$time>300){
                die(); //定期
            }

            $this->filename = '分渠道结算-'.date('Y_m_d') . '.xlsx';
            /*$this->filename = RedisModel::rPop($rkey);
            if(empty($this->filename)){
                sleep(2);
                continue;
            }*/
            
            $excel = new ExcelCutHelper();
            $files = $this->readFiles();
            if(empty($files)){
                return;
            }

            ZeanExcelRecord::query()->delete(); //清除原有数据
            
            foreach($files as $filePath){
                $source = strstr(basename($filePath), '.xlsx', true);
                $data = $excel->cutFromFile($filePath, $source);
                //echo "\nCCC";
                if($data == 49999){
                    $this->stat($filePath, $source, 'xlsx'); //小于49999，直接处理
                } else {

                    #获取列序列
                    $sourcefile1 = public_path("upload/csv/".$source).'/'.$source.'_0.Csv';

                    $cn = $this->getCsvColSort($sourcefile1);

                    $flitFiles = $this->readCsvFiles($source);
                    foreach($flitFiles as $csvPath){
                        $first = $csvPath == $sourcefile1 ? 1 : 0;
                        $this->stat($csvPath, $source, 'Csv', $cn, $first); 
                    }

                    @unlink($filePath);
                }

            }

            $this->exportInfo();
            
            $this->info(date('m-d H:i:s') . ' 整理结束');

            $this->filename = null;
        }
    }

    public function getCsvColSort($filePath)
    {
        //echo "\nDDD";
        //echo "\n".$filePath;
        
        //$reader = new \PhpOffice\PhpSpreadsheet\Reader\Csv();
        //$spreadsheet = $reader->load($filePath);
        $spreadsheet = \PhpOffice\PhpSpreadsheet\IOFactory::load($filePath);
        //echo "\nEEE";
        $data = $spreadsheet->getActiveSheet()->toArray();

        $columns = ['供应商全称', '供应商简称', '发票类型', '税率', '结算金额', '结算类型'];
        $col_t = array_flip($columns);

        $cn = array();
        $row = array_shift($data);

        //确认需要的列
        foreach($row as $col_key => $col_val){
            $col_val = trim($col_val, '"');
            if(in_array($col_val, $columns)){
                $cn[$col_t[$col_val]] = $col_key;
            }
        }

        if(count($cn) !== 6){
            $this->info(date('m-d H:i:s') . ' csv-1文件格式有误 '. $filePath);
            return ;
        }

        ksort($cn);

        //echo "\nFFF";

        return $cn;            
    }

    public function stat($filePath, $source, $ext='xlsx', $cn=[], $first=0)
    {
        // 获取编码
        /*$content = file_get_contents($filePath);
        $strCode = mb_detect_encoding($content, ["ASCII", "GB2312", "GBK", "UTF-8"]);*/

        if($ext == 'xlsx'){
            $reader = new \PhpOffice\PhpSpreadsheet\Reader\Xlsx();
        } else {
            $reader = new \PhpOffice\PhpSpreadsheet\Reader\Csv();
        }

        //$reader->setInputEncoding($strCode);
        $spreadsheet = $reader->load($filePath);
        $data = $spreadsheet->getActiveSheet()->toArray();

        $columns = ['供应商全称', '供应商简称', '发票类型', '税率', '结算金额', '结算类型'];
        $col_t = array_flip($columns);

        try {
            $list = array();
            
            foreach ($data as $k => $row) {

                if(!$row[0]){
                    break;
                }

                if($ext == 'xlsx' && $k == 0){
                    //确认需要的列
                    foreach($row as $col_key => $col_val){
                        if(in_array($col_val, $columns)){
                            $cn[$col_t[$col_val]] = $col_key;
                        }
                    }

                    if(count($cn) !== 6){
                        $this->info(date('m-d H:i:s') . ' 文件格式有误 '. $source);
                        return ;
                    }
                    ksort($cn);
                    continue;
                } elseif($ext == 'Csv' && $k==0 && $first){
                    //echo "\n888888";
                    continue;
                } 

                if($row[$cn[0]] == '供应商全称' && $row[$cn[1]] == '供应商简称'){
                    continue;
                }

                //echo "\n33333";

                $list[] = [
                    'source' => $source, 
                    'title' => trim($row[$cn[0]], "\"\""), 
                    'short' => trim($row[$cn[1]], "\"\""), 
                    'ptype' => trim($row[$cn[2]], "\"\""), 
                    'rate' => floatval(trim($row[$cn[3]], "\"\"")), 
                    'amount' => floatval(trim($row[$cn[4]], "\"\"")), 
                    'jtype' => trim($row[$cn[5]], "\"\"") 
                ];

                if(count($list)>=1000){
                    $res = ZeanExcelRecord::insert($list);
                    $this->info(date('m-d H:i:s') . ' 插入1000条 '. $source);
                    $list = array();
                }
                //echo "\n44444";

            }

            if(!empty($list)){
                ZeanExcelRecord::insert($list);
                $en = count($list);
                $this->info(date('m-d H:i:s') . ' 插入'.$en.'条 '. $source);
                $list = null;
            }
            //echo "\n55555";
            $spreadsheet->disconnectWorksheets();
            unset($spreadsheet);
            unset($data);
            unset($reader);
            @unlink($filePath);

        } catch (\Exception $e) {

            Log::logError(date('m-d H:i:s') . ' '.$e->getMessage(), [
                'param' => $data,
                'trace' => $e->getTraceAsString()
            ], 'ZeanExcel');

        }

        return ;

    }

    function exportInfo()
    {
        $sources = ZeanExcelRecord::selectRaw('distinct(source)')->get();
        foreach($sources as $val){
            $this->doExport($val['source']);
        }
    }

    function doExport($source){

        $fname = $this->filename;
        $template_path = public_path('upload/export/'.$fname); // 读取模板

        if(!file_exists($template_path)){
            $spreadsheet = new \PhpOffice\PhpSpreadsheet\Spreadsheet();
            $worksheet = $spreadsheet->getActiveSheet();
            $worksheet->getCell('A1')->setValue('渠道');
            $worksheet->getCell('B1')->setValue('供应商全称');
            $worksheet->getCell('C1')->setValue('供应商简称');
            $worksheet->getCell('D1')->setValue('发票类型');
            $worksheet->getCell('E1')->setValue('税率');
            $worksheet->getCell('F1')->setValue('结算金额');
            $worksheet->getCell('G1')->setValue('结算类型');   
        } else {
            $spreadsheet = \PhpOffice\PhpSpreadsheet\IOFactory::load($template_path);// 以下代码行将活动工作表索引设置为第一个工作表：设置Excel Sheet
            $spreadsheet->setActiveSheetIndex(0);// 指向激活的工作表
            $worksheet = $spreadsheet->getActiveSheet();
        }

        $row_max = $worksheet->getHighestRow();

        $offset = 0;
        while(true){
            $infos = $this->getData($source, $offset);

            foreach($infos as $item){
                $row_max++;
                $worksheet->getCell('A'.$row_max)->setValue($item->source);
                $worksheet->getCell('B'.$row_max)->setValue($item->title);
                $worksheet->getCell('C'.$row_max)->setValue($item->short);
                $worksheet->getCell('D'.$row_max)->setValue($item->ptype);
                $worksheet->getCell('E'.$row_max)->setValue($item->rate);
                $worksheet->getCell('F'.$row_max)->setValue($item->amount);
                $worksheet->getCell('G'.$row_max)->setValue($item->jtype);
            }

            if(count($infos)<1000){
                break;
            }
        }

        $writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, 'Xlsx');
        $writer->save($template_path);



        // 结束 进行导出
        /*ob_end_clean(); // 清空（擦除）缓冲区并关闭输出缓冲
        ob_start(); // 打开输出控制缓冲
        $date = date("Ymd",time());$listname = 'hello'.$date;
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="'.$listname . '.xlsx"');
        header('Cache-Control: max-age=0');
        $writer = IOFactory::createWriter($spreadsheet, 'Xlsx');
        $writer->save('php://output');*/
    }

    function getData($source, &$offset=0)
    {
        $infos = ZeanExcelRecord::selectRaw('source, title, short, ptype, rate, sum(amount) as amount, jtype')
            ->where('source', $source)
            ->groupBy('title')
            ->orderBy('title')
            ->offset($offset)
            ->limit(1000)
            ->get();

        $offset+=1000;

        return $infos;
    }

    function readFiles()
    {
        $filePaths = array();
        $dir = public_path("upload/excel/");  // 文件夹路径

        if ($dh = opendir($dir)) {  // 打开文件夹
            while (($file = readdir($dh)) !== false) {  // 读取文件夹中的所有文件
                if ($file != "." && $file != "..") {  // 排除.和..文件
                    echo "文件名：" . $file . "\n";
                    $filePaths[] = $dir . $file;
                }
            }
            closedir($dh);  // 关闭文件夹
        }

        return $filePaths;
    }

    function readCsvFiles($source)
    {
        //echo "\nGGG";
        $filePaths = array();
        $dir = public_path("upload/csv/".$source.'/');  // 文件夹路径

        if ($dh = opendir($dir)) {  // 打开文件夹
            while (($file = readdir($dh)) !== false) {  // 读取文件夹中的所有文件
                if ($file != "." && $file != "..") {  // 排除.和..文件
                    echo "文件名：" . $file . "\n";
                    $filePaths[] = $dir . $file;
                }
            }
            closedir($dh);  // 关闭文件夹
        }

        return $filePaths;
    }

}


/**
 * 预读过滤类
 * @author wangyelou
 * @date 2018-07-30
 */
class MyAheadreadFilter implements \PhpOffice\PhpSpreadsheet\Reader\IReadFilter
{
    public $record = array();
    private $lastRow = '';
    
    public function readCell($column, $row, $worksheetName = '')
    {
        if (isset($this->record[$worksheetName]) ) {
            if ($this->lastRow != $row) {
                $this->record[$worksheetName] ++;
                $this->lastRow = $row;
            }
        } else {
            $this->record[$worksheetName] = 1;
            $this->lastRow = $row;
        }
        return false;
    }
}
 
/**
 * 解析过滤类
 * @author wangyelou
 * @date 2018-07-30
 */
class MyreadFilter implements \PhpOffice\PhpSpreadsheet\Reader\IReadFilter
{
    public $startRow;
    public $endRow;
    public $worksheetName;
    
    public function readCell($column, $row, $worksheetName = '')
    {
        if ($worksheetName == $this->worksheetName && $row >= ($this->startRow+1) && $row <= ($this->endRow+1)) {
            return true;
        }
        return false;
    }
}
 
/**
 * 切割类
 * @author wangyelou
 * @date 2018-07-30
 */
class ExcelCutHelper
{
    public $cutNum = 3;
    public $returnType = 'Csv';
    public $fileDir = 'upload/csv/';
    public $log;

    /**
     * 切割字符串
     * @param $str
     * @return array|bool
     */
    public function cutFromStr($str)
    {
        try {
            $filePath = '/tmp/' . time() . mt_rand(1000, 9000) . $this->returnType;
            file_put_contents($filePath, $str);
            if (file_exists($filePath)) {
                $result =  $this->cutFromFile($filePath);
                unlink($filePath);
                return $result;
            } else {
                throw new Exception('文件写入错误');
            }
        } catch (Exception $e) {
            $this->log = $e->getMessage();
            return false;
        }

    }

    /**
     * 切割文件
     * @param $file
     * @return array|bool
     */
    public function cutFromFile($file, $source)
    {
        try {
            $cutRules = $this->readaheadFromFile($file);
            if($cutRules == 49999){
                return 49999;
            }

            $dir = $this->getFileDir($source);
            $returnType = $this->returnType ? $this->returnType : 'Csv';
            $results = array();
            //初始化读
            $myFilter = new MyreadFilter();
            $inputFileType = \PhpOffice\PhpSpreadsheet\IOFactory::identify($file);
            $reader = \PhpOffice\PhpSpreadsheet\IOFactory::createReader($inputFileType);
            $reader->setReadDataOnly(true);
            $reader->setReadFilter($myFilter);
            
            //echo "\nAAA";
            foreach ($cutRules as $sheetName => $rowIndexRange) {
                //读
                list($myFilter->startRow, $myFilter->endRow, $myFilter->worksheetName) = $rowIndexRange;
                $spreadsheetReader = $reader->load($file);
                $sheetData = $spreadsheetReader->setActiveSheetIndexByName($myFilter->worksheetName)->toArray(null, false, false, false);
                $realDatas = array_splice($sheetData, $myFilter->startRow, ($myFilter->endRow - $myFilter->startRow + 1));
                $spreadsheetReader->disconnectWorksheets();
                unset($sheetData);
                unset($spreadsheetReader);
                
                //写
                $saveFile = $dir . $sheetName . '.' . $returnType;
                $spreadsheetWriter = new \PhpOffice\PhpSpreadsheet\Spreadsheet();
                foreach ($realDatas as $rowIndex => $row) {
                    foreach ($row as $colIndex => $col) {
                        $spreadsheetWriter->getActiveSheet()->setCellValueByColumnAndRow($colIndex+1, $rowIndex+1, $col);
                    }
                }
                $writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheetWriter, $returnType);
                $writer->save($saveFile);
                $spreadsheetWriter->disconnectWorksheets();
                unset($spreadsheetWriter);
                $results[] = $saveFile;
                //echo "\nXXX";
            }

            //echo "\nBBB";
            unset($myFilter);
            unset($reader);
            
            return $results;
            
        } catch (Exception $e) {
            $this->log = $e->getMessage();
            return false;
        }
    }
    
    /**
     * 预读文件
     */
    public  function readaheadFromFile($file)
    {
        if (file_exists($file)) {
            
            //获取统计数据
            $myFilter = new MyAheadreadFilter();
            $inputFileType = \PhpOffice\PhpSpreadsheet\IOFactory::identify($file);
            $reader = \PhpOffice\PhpSpreadsheet\IOFactory::createReader($inputFileType);
            $reader->setReadDataOnly(true); //只读数据
            $reader->setReadFilter($myFilter);
            $spreadsheet = $reader->load($file);
            //$sheetData = $spreadsheet->getActiveSheet()->toArray(null, false, false, false);
            list($fileName,) = explode('.', basename($file));
            $datas = array();

            $fcount = reset($myFilter->record); //第一个工作表个数

            //echo "\n总条数：".$fcount;

            if($fcount<50000){
                return 49999; //50000条一下不处理
            }

            //大于15万后重新计算分割数，保证每个表最多4万
            if($fcount > 130000){
                $this->cutNum = ceil($fcount / 40000);
            }

            $averageNum = ceil($fcount / $this->cutNum);

            foreach ($myFilter->record as $sheetName => $count) {
                for ($i=0; $i<ceil($count/$averageNum); $i++) {
                    $datas[$fileName . '_' . $i] = array($i*$averageNum, ($i+1)*$averageNum-1, $sheetName);
                }
                break;
            }

            unset($myFilter);
            unset($reader);
            
            return $datas;
        } else {
            throw new Exception($file . ' not exists');
        }
    }
    
    /**
     * 创建目录
     * @param $file
     * @return bool|string
     */
    protected function getFileDir($source)
    {
        $path = public_path("upload/csv/") . $source . '/';
        if (is_dir($path)) {
            return $path;
        }

        mkdir($path, 0777);
        chmod($path, 0777);
        
        if (is_dir($path)) {
            return $path;
        } else {
            $this->log = "mkdir {$path} failed";
            return false;
        }
    }
    
    
    
}


      